<?php
if(count(get_included_files())==1) exit("No direct script access allowed");  
$total_users = $conexao['localhost']->query("SELECT * FROM clientes")->total();
$total_emails = $conexao['localhost']->query("SELECT * FROM fila_disparos WHERE email_status=?", 1)->total();
$total_whats = $conexao['localhost']->query("SELECT * FROM fila_disparos WHERE whatsapp=?", 1)->total();
$total_erros = $conexao['localhost']->query("SELECT * FROM error_log")->total();
?>
<div class="row">
    <div class="col-lg-6">
        <div class="row">
            <div class="col-md-6">
                <div class="card card-animate">
                    <div class="card-body">
                        <div class="d-flex justify-content-between">
                            <div>
                                <p class="fw-medium text-muted mb-0">Usuários</p>
                                <h2 class="mt-4 ff-secondary fw-semibold"><span class="counter-value" data-target="<?=$total_users;?>">0</span></h2>
                                
                            </div>
                            <div>
                                <div class="avatar-sm flex-shrink-0">
                                    <span class="avatar-title bg-primary rounded-circle fs-2">
                                        <i data-feather="users"></i>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div><!-- end card body -->
                </div> <!-- end card-->
            </div> <!-- end col-->

            <div class="col-md-6">
                <div class="card card-animate">
                    <div class="card-body">
                        <div class="d-flex justify-content-between">
                            <div>
                                <p class="fw-medium text-muted mb-0">Disparos de E-mail</p>
                                <h2 class="mt-4 ff-secondary fw-semibold"><span class="counter-value" data-target="<?=$total_emails;?>">0</span></h2>
                                
                            </div>
                            <div>
                                <div class="avatar-sm flex-shrink-0">
                                    <span class="avatar-title bg-danger rounded-circle fs-2">
                                        <i data-feather="mail"></i>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div><!-- end card body -->
                </div> <!-- end card-->
            </div> <!-- end col-->
        </div> <!-- end row-->

        <div class="row">
            <div class="col-md-6">
                <div class="card card-animate">
                    <div class="card-body">
                        <div class="d-flex justify-content-between">
                            <div>
                                <p class="fw-medium text-muted mb-0">Disparos via WhatsApp</p>
                                <h2 class="mt-4 ff-secondary fw-semibold"><span class="counter-value" data-target="<?=$total_whats;?>">0</span></h2>
                                
                            </div>
                            <div>
                                <div class="avatar-sm flex-shrink-0">
                                    <span class="avatar-title bg-danger rounded-circle fs-2">
                                        <i data-feather="message-circle"></i>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div><!-- end card body -->
                </div> <!-- end card-->
            </div> <!-- end col-->

            <div class="col-md-6">
                <div class="card card-animate">
                    <div class="card-body">
                        <div class="d-flex justify-content-between">
                            <div>
                                <p class="fw-medium text-muted mb-0">Erros de Disparos</p>
                                <h2 class="mt-4 ff-secondary fw-semibold"><span class="counter-value" data-target="<?=$total_erros;?>">0</span></h2>
                                
                            </div>
                            <div>
                                <div class="avatar-sm flex-shrink-0">
                                    <span class="avatar-title bg-success rounded-circle fs-2">
                                        <i data-feather="external-link"></i>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div><!-- end card body -->
                </div> <!-- end card-->
            </div> <!-- end col-->
        </div> <!-- end row-->
    </div>

    <div class="col-lg-6">
        <div class="card">
            <div class="card-header">
                <h4 class="card-title">Relátorio de Envio Diário</h4>
            </div>
            <div class="card-body">
                <!-- Striped Rows -->
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th scope="col">Id</th>
                            <th scope="col">Cliente</th>
                            <th scope="col">Tipo</th>
                            <th scope="col">Status</th>
                            <th scope="col"></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php 
                            $relatorio = $conexao['localhost']->query('SELECT * FROM relatorio ORDER BY data DESC limit 10')->fetchAll();
                            foreach ($relatorio as $result) {
                        ?>
                        <tr>
                            <th scope="row"><?=$result['id'];?></th>
                            <td><?=$result['cliente'];?></td>
                            <td><?=relatorio($result['tipo']);?></td>
                            <td><span class="badge bg-success"><?=statusLog($result['status']);?></span></td>
                            <td><?=date("d/m/y H:i:s", strtotime($result['data']));?></td>
                        </tr>
                        <?php }?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div> <!-- End analises --: