
<?php 
class perfectworld {
    protected $connection;
    protected $query;
    protected $show_errors = TRUE;
    protected $query_closed = TRUE;
    public    $query_count = 0;
    
    public function __construct($dbhost = 'localhost', $dbuser = 'root', $dbpass = '', $dbname = '', $charset = 'utf8') {
    $this->connection = new mysqli($dbhost, $dbuser, $dbpass, $dbname);
    if ($this->connection->connect_error) {
    $this->error('<pre>Falha ao conectar ao MySQL - ' . $this->connection->connect_error.'</pre>');
    }
    $this->connection->set_charset($charset);
    }
    
    public function query($query) {
    if (!$this->query_closed) {
    $this->query->close();
    }
    if ($this->query = $this->connection->prepare($query)) {
    if (func_num_args() > 1) {
    $x = func_get_args();
    $args = array_slice($x, 1);
    $types = '';
    $args_ref = array();
    foreach ($args as $k => &$arg) {
    if (is_array($args[$k])) {
    foreach ($args[$k] as $j => &$a) {
    $types .= $this->_gettype($args[$k][$j]);
    $args_ref[] = &$a;
    }
    } else {
    $types .= $this->_gettype($args[$k]);
    $args_ref[] = &$arg;
    }
    }
    array_unshift($args_ref, $types);
    call_user_func_array(array($this->query, 'bind_param'), $args_ref);
    }
    $this->query->execute();
    if ($this->query->errno) {
    $this->error('<pre>Não foi possível executar a consulta (parâmetros)<br>' . $this->query->error.'</pre>');
    var_dump($this->query->error);
    }
    $this->query_closed = FALSE;
    $this->query_count++;
    } else {
    $this->error('<pre>Não foi possível executar a instrução (sintaxe)<br>' . $this->connection->error.'</pre>');
    }
    return $this;
    }
    
    
    public function fetchAll($callback = null) {
    $params = array();
    $row = array();
    $meta = $this->query->result_metadata();
    while ($field = $meta->fetch_field()) {
    $params[] = &$row[$field->name];
    }
    call_user_func_array(array($this->query, 'bind_result'), $params);
    $result = array();
    while ($this->query->fetch()) {
    $r = array();
    foreach ($row as $key => $val) {
    $r[$key] = $val;
    }
    if ($callback != null && is_callable($callback)) {
    $value = call_user_func($callback, $r);
    if ($value == 'break') break;
    } else {
    $result[] = $r;
    }
    }
    $this->query->close();
    $this->query_closed = TRUE;
    return $result;
    }
    
    public function fetchArray() {
    $params = array();
    $row = array();
    $meta = $this->query->result_metadata();
    while ($field = $meta->fetch_field()) {
    $params[] = &$row[$field->name];
    }
    call_user_func_array(array($this->query, 'bind_result'), $params);
    $result = array();
    while ($this->query->fetch()) {
    foreach ($row as $key => $val) {
    $result[$key] = $val;
    }
    }
    $this->query->close();
    $this->query_closed = TRUE;
    return $result;
    }
    
    public function fechar() {
    return $this->connection->close();
    }
    
    public function total() {
    $this->query->store_result();
    return $this->query->num_rows;
    }
    
    public function linhas() {
    return $this->query->affected_rows;
    }
    
    public function ultimoID() {
    return $this->connection->insert_id;
    }
    
    public function error($error) {
    if ($this->show_errors) {
    exit($error);
    }
    }
    
    private function _gettype($var) {
    if (is_string($var)) return 's';
    if (is_float($var)) return 'd';
    if (is_int($var)) return 'i';
    return 'b';
    }
    }
    
    
    class url {
    private static $url = null;
    private static $baseUrl = null;
    
    public static function pegar($id){
    if(self::$url == null)
    self::listar();
    if(isset(self::$url[$id]))
    return self::$url[$id];
    return null;
    }
    
    public static function base(){
    if(self::$baseUrl != null)
    return self::$baseUrl;
    global $_SERVER;
    $startUrl = strlen($_SERVER["DOCUMENT_ROOT"]);
    $excludeUrl = substr($_SERVER["SCRIPT_FILENAME"], $startUrl, -9);
    if($excludeUrl[0] == "/")
    self::$baseUrl = $excludeUrl; 
    else
    self::$baseUrl = "/" . $excludeUrl;
    return self::$baseUrl;
    }
    
    private static function listar(){
    global $_SERVER;
    $startUrl     = strlen($_SERVER["DOCUMENT_ROOT"]) -1;
    $excludeUrl   = substr($_SERVER["SCRIPT_FILENAME"], $startUrl, -10);
    $request      = $_SERVER['REQUEST_URI'];
    $request      = substr($request, strlen($excludeUrl));
    $urlTmp       = explode("?", $request);
    $request      = $urlTmp[0];
    $urlExplodida = explode("/", $request);
    $retorna = array();
    
    for($a = 0; $a <= count($urlExplodida); $a ++){
    if(isset($urlExplodida[$a]) AND $urlExplodida[$a] != ""){
    array_push($retorna, $urlExplodida[$a]);
    }
    }
    self::$url = $retorna;
    }
    }

    function alerts2($tipo,$mensagem){
        if ($tipo == "Falha") {
            $cor = 'danger';
        }elseif ($tipo == "Sucesso") {
            $cor = 'success';
        }elseif ($tipo == "Infor") {
            $cor = 'info';
        }
        echo '<div class="row alerts2">
        <div data-aos="fade-up">
        <div class="col-lg-12">
            <!-- Primary Alert -->
            <div class="alert alert-'.$cor.' alert-dismissible shadow fade show" role="alert">
                <strong> '.$tipo.': </strong> '.$mensagem.'
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
        
        </div>
        </div>
    </div>';
    }

global $conexao;
    


//formatar CPF ou CNPJ
function formatarDados($cpf) {
    $numero = preg_replace('/[^0-9]/', '', $cpf);

    // Verificar o tamanho do número
    $tamanho = strlen($numero);

    if ($tamanho == 11) {
        $cpf_formatado = substr($numero, 0, 3) . '.' . substr($numero, 3, 3) . '.' . substr($numero, 6, 3) . '-' . substr($numero, 9, 2);
        return $cpf_formatado;
    } elseif ($tamanho == 14) {
        $cnpj_formatado = substr($numero, 0, 2) . '.' . substr($numero, 2, 3) . '.' . substr($numero, 5, 3) . '/' . substr($numero, 8, 4) . '-' . substr($numero, 12, 2);

        return $cnpj_formatado;
    }

    
}

function logado(){
    if (!isset($_SESSION['superpainel']) || $_SESSION['superpainel'] !== true) {
    return false;
    }
    return true;
    }



function senha_hash($login, $senha, $hash){
    switch ($hash) {
    case 1: return '0x'.md5($login.$senha); break;
    case 2: return md5($login.$senha); break;
    case 3: return base64_encode(md5($login.$senha, true)); break;
    case 4: return base64_encode($login.$senha); break;
    default: return base64_encode(md5($login.$senha, true)); break;
    }
    }

    $p  = url::pegar(0);
if($p == "login"){ $title = 'Fazer Login'; }
elseif($p == "cadastro"){ $title = 'Cadastrar Cliente'; }
elseif($p == "recuperar-conta"){ $title = 'Recuperar Conta'; }
elseif($p == "reenviar"){ $title = 'Reenviar E-mail'; }
elseif($p == "extensoes"){ $title = 'Módulos & Extensões'; }
elseif($p == "func"){ $title = 'Central de ações'; }
elseif($p == "chat"){ $title = 'Central de ações'; }
elseif($p == "smtp"){$title = 'Configuração de SMTP';}
elseif($p == "templates-disparos"){$title = 'Modelos de Envio';}
elseif ($p == "") {$title = 'Fazer Login';
}
else { $title = ucfirst(strip_tags(htmlspecialchars($p))); }

function pegar_ip() {
    $ip = null;
    if(isset($_SERVER['HTTP_CLIENT_IP']))
    $ip = $_SERVER['HTTP_CLIENT_IP'];
    elseif(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    elseif(isset($_SERVER['HTTP_X_FORWARDED']))
    $ip = $_SERVER['HTTP_X_FORWARDED'];
    elseif(isset($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']))
    $ip = $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
    elseif(isset($_SERVER['HTTP_FORWARDED_FOR']))
    $ip = $_SERVER['HTTP_FORWARDED_FOR'];
    elseif(isset($_SERVER['HTTP_FORWARDED']))
    $ip = $_SERVER['HTTP_FORWARDED'];
    elseif(isset($_SERVER['REMOTE_ADDR']))
    $ip = $_SERVER['REMOTE_ADDR'];
    else
    $ip = 'Desconhecido';
    return $ip;
    }

//Formatar Numero
function formatarTelefone($numero) {
    // Adicionar parênteses e traço ao número de telefone
    $telefone_formatado = '+'. substr($numero, 0, 2) .'(' . substr($numero, 2, 2) . ') ' . substr($numero, 4, 2) . substr($numero, 6, 2).'-' . substr($numero, 8, 7);

    return $telefone_formatado;
}

function detectPast($past){
    $pasta = "files/$past";

// Verifica se a pasta já existe
if (!is_dir($pasta)) {
    // Cria a pasta com permissões de escrita
    mkdir($pasta, 0777);
}
}

function gerador($tamanho=15){
    $salt = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    $tam = strlen($salt);
    $pass = '';
    mt_srand(10000000*(double)microtime());
    for ($i = 0; $i < $tamanho; $i++){
    $pass .= $salt[mt_rand(0,$tam - 1)];
    }
    return $pass;
    }



function relatorio($tipo){
    switch($tipo){
        case 0: $tipo = 'Whatsapp'; break;
        case 1: $tipo = 'E-mail'; break;
        case 2: $tipo = 'Whatsapp e E-mail'; break;
        default: $tipo = 'Desconhecido'; break;
    }
    return $tipo;
}

function statusLog($tipo){
    switch($tipo){
        case 0: $tipo = 'Erro'; break;
        case 1: $tipo = 'Finalizado'; break;
        default: $tipo = 'Desconhecido'; break;
    }
    return $tipo;
}

function saudacao($nome = '') {
    date_default_timezone_set('America/Sao_Paulo');
    $hora = date('H');
    if($hora >= 6 && $hora <= 12)
    return 'Bom dia' . (empty($nome) ? '' : ', ' . $nome);
    else if ( $hora > 12 && $hora <=18  )
    return 'Boa tarde' . (empty($nome) ? '' : ', ' . $nome);
    else
    return 'Boa noite' . (empty($nome) ? '' : ', ' . $nome);
    }

function logs($razao){
    global $conexao,$ip;
    date_default_timezone_set('America/Sao_Paulo');
    $conexao['localhost']->query("INSERT INTO logs (detalhe, ip, data) VALUES (?,?,?)", $razao, $ip, date("Y-m-d H:i:s"));
}




function url($string) {
    if($string !== mb_convert_encoding(mb_convert_encoding($string, 'UTF-32', 'UTF-8'), 'UTF-8', 'UTF-32'))
    $string = mb_convert_encoding($string, 'UTF-8', mb_detect_encoding($string));
    $string = htmlentities($string, ENT_NOQUOTES, 'UTF-8');
    $string = preg_replace('`&([a-z]{1,2})(acute|uml|circ|grave|ring|cedil|slash|tilde|caron|lig);`i', '\1', $string);
    $string = html_entity_decode($string, ENT_NOQUOTES, 'UTF-8');
    $string = preg_replace(array('`[^a-z0-9]`i','`[-]+`'), ' ', $string);
    $string = preg_replace('/( ){2,}/', '$1', $string);
    $string = trim($string);
    $string = str_replace(' ', '_', $string);
    return strtolower($string);
    }

function logCron($string){
    global $conexao;
    if ($conexao['localhost']->query("INSERT INTO cron_tasks (detalhes,data) VALUES (?,?)", $string, date("Y-m-d H:i:s"))) {
        
    }
}

function pages($nome){
    if ($nome == "cadastrar-grupos") {
        return $nome = "Cadastrar Grupos";
    }elseif ($nome == "cadastro") {
        return $nome = "Cadastrar Clientes";
    }elseif ($nome == "clientes") {
        return $nome = "Clientes";
    }elseif ($nome == "create-user") {
        return $nome = "Criar Usuário";
    }elseif ($nome == "disparos-grupo") {
        return $nome = "Disparos em Grupos";
    }elseif ($nome == "disparos") {
        return $nome = "Disparos Individuais";
    }elseif ($nome == "templates-disparos") {
        return $nome = "Modelos de Envio";
    }elseif ($nome == "grupos") {
        return $nome = "Grupos (WhatsApp)";
    }elseif ($nome == "logs") {
        return $nome = "Logs";
    }elseif ($nome == "permission") {
        return $nome = "Configurar Permissões";
    }elseif ($nome == "restaurar") {
        return $nome = "Restaurar Cliente";
    }elseif ($nome == "sessao") {
        return $nome = "Configurar Sessão";
    }elseif ($nome == "smtp") {
        return $nome = "Configurar SMTP";
    }elseif ($nome == "usuarios") {
        return $nome = "Usuários";
    }elseif ($nome == "agendamentos") {
        return $nome = "Agendamentos";
    }
}



